diff -r e16bdc0054ce src/widgets/graph_widget.h
--- a/src/widgets/graph_widget.h
+++ b/src/widgets/graph_widget.h
@@ -29,6 +29,10 @@
 	WID_CV_BACKGROUND, ///< Background of the window.
 	WID_CV_GRAPH,      ///< Graph itself.
 	WID_CV_RESIZE,     ///< Resize button.
+	WID_CPR2_FOOTER,          ///< Footer.
+	WID_CPR2_ENABLE_CARGOES,  ///< Enable cargoes button.
+	WID_CPR2_DISABLE_CARGOES, ///< Disable cargoes button.
+	WID_CPR2_CARGO_FIRST,     ///< First cargo in the list.
 };
 
 /** Widget of the #PerformanceHistoryGraphWindow class. */
diff -r e16bdc0054ce src/widgets/industry_widget.h
--- a/src/widgets/industry_widget.h
+++ b/src/widgets/industry_widget.h
@@ -19,6 +19,8 @@
 	WID_DPI_INFOPANEL,      ///< Info panel about the industry.
 	WID_DPI_DISPLAY_WIDGET, ///< Display chain button.
 	WID_DPI_FUND_WIDGET,    ///< Fund button.
+	WID_DPI_FT_OFF,         ///< Forbidden tiles highlight off button.
+	WID_DPI_FT_ON,          ///< Forbidden tiles highlight on button.
 };
 
 /** Widgets of the #IndustryViewWindow class. */
@@ -34,6 +36,7 @@
 enum IndustryDirectoryWidgets {
 	WID_ID_DROPDOWN_ORDER,    ///< Dropdown for the order of the sort.
 	WID_ID_DROPDOWN_CRITERIA, ///< Dropdown for the criteria of the sort.
+	WID_ID_DROPDOWN_FILTER,   ///< Industry filter
 	WID_ID_INDUSTRY_LIST,     ///< Industry list.
 	WID_ID_SCROLLBAR,         ///< Scrollbar of the list.
 };
diff -r e16bdc0054ce src/widgets/network_widget.h
--- a/src/widgets/network_widget.h
+++ b/src/widgets/network_widget.h
@@ -51,6 +51,11 @@
 	WID_NG_ADD,                ///< 'Add server' button.
 	WID_NG_START,              ///< 'Start server' button.
 	WID_NG_CANCEL,             ///< 'Cancel' button.
+
+	WID_NG_CITYMANIA,          ///< filter citymania
+	WID_NG_REDDIT,             ///< filter reddit
+	WID_NG_NICE,               ///< filter n-ice
+	WID_NG_BTPRO,              ///< filter btpro
 };
 
 /** Widgets of the #NetworkStartServerWindow class. */
diff -r e16bdc0054ce src/widgets/rail_widget.h
--- a/src/widgets/rail_widget.h
+++ b/src/widgets/rail_widget.h
@@ -21,6 +21,7 @@
 	WID_RAT_BUILD_EW,       ///< Build rail along the game view X axis.
 	WID_RAT_BUILD_Y,        ///< Build rail along the game grid Y axis.
 	WID_RAT_AUTORAIL,       ///< Autorail tool.
+	WID_RAT_POLYRAIL,       ///< Polyline rail tool.
 	WID_RAT_DEMOLISH,       ///< Destroy something with dynamite!
 	WID_RAT_BUILD_DEPOT,    ///< Build a depot.
 	WID_RAT_BUILD_WAYPOINT, ///< Build a waypoint.
@@ -99,10 +100,11 @@
 /** Widgets of the #BuildRailDepotWindow class. */
 enum BuildRailDepotWidgets {
 	/* Name starts with BRA instead of BR, because of collision with BuildRoadDepotWidgets */
-	WID_BRAD_DEPOT_NE, ///< Build a depot with the entrance in the north east.
-	WID_BRAD_DEPOT_SE, ///< Build a depot with the entrance in the south east.
-	WID_BRAD_DEPOT_SW, ///< Build a depot with the entrance in the south west.
-	WID_BRAD_DEPOT_NW, ///< Build a depot with the entrance in the north west.
+	WID_BRAD_DEPOT_NE,   ///< Build a depot with the entrance in the north east.
+	WID_BRAD_DEPOT_SE,   ///< Build a depot with the entrance in the south east.
+	WID_BRAD_DEPOT_SW,   ///< Build a depot with the entrance in the south west.
+	WID_BRAD_DEPOT_NW,   ///< Build a depot with the entrance in the north west.
+	WID_BRAD_DEPOT_AUTO, ///< Build a depot, autoselect entrance.
 };
 
 /** Widgets of the #BuildRailWaypointWindow class. */
diff -r e16bdc0054ce src/widgets/road_widget.h
--- a/src/widgets/road_widget.h
+++ b/src/widgets/road_widget.h
@@ -17,7 +17,8 @@
 	/* Name starts with RO instead of R, because of collision with RailToolbarWidgets */
 	WID_ROT_ROAD_X,         ///< Build road in x-direction.
 	WID_ROT_ROAD_Y,         ///< Build road in y-direction.
-	WID_ROT_AUTOROAD,       ///< Autorail.
+	WID_ROT_AUTOROAD,       ///< Autoroad.
+	WID_ROT_FULLROAD,       ///< Auto full road (no half-tiles).
 	WID_ROT_DEMOLISH,       ///< Demolish.
 	WID_ROT_DEPOT,          ///< Build depot.
 	WID_ROT_BUS_STATION,    ///< Build bus station.
@@ -31,27 +32,30 @@
 /** Widgets of the #BuildRoadDepotWindow class. */
 enum BuildRoadDepotWidgets {
 	/* Name starts with BRO instead of BR, because of collision with BuildRailDepotWidgets */
-	WID_BROD_CAPTION,   ///< Caption of the window.
-	WID_BROD_DEPOT_NE,  ///< Depot with NE entry.
-	WID_BROD_DEPOT_SE,  ///< Depot with SE entry.
-	WID_BROD_DEPOT_SW,  ///< Depot with SW entry.
-	WID_BROD_DEPOT_NW,  ///< Depot with NW entry.
+	WID_BROD_CAPTION,    ///< Caption of the window.
+	WID_BROD_DEPOT_NE,   ///< Depot with NE entry.
+	WID_BROD_DEPOT_SE,   ///< Depot with SE entry.
+	WID_BROD_DEPOT_SW,   ///< Depot with SW entry.
+	WID_BROD_DEPOT_NW,   ///< Depot with NW entry.
+	WID_BROD_DEPOT_AUTO, ///< Depot, autodetect entry.
 };
 
 /** Widgets of the #BuildRoadStationWindow class. */
 enum BuildRoadStationWidgets {
 	/* Name starts with BRO instead of BR, because of collision with BuildRailStationWidgets */
-	WID_BROS_CAPTION,       ///< Caption of the window.
-	WID_BROS_BACKGROUND,    ///< Background of the window.
-	WID_BROS_STATION_NE,    ///< Terminal station with NE entry.
-	WID_BROS_STATION_SE,    ///< Terminal station with SE entry.
-	WID_BROS_STATION_SW,    ///< Terminal station with SW entry.
-	WID_BROS_STATION_NW,    ///< Terminal station with NW entry.
-	WID_BROS_STATION_X,     ///< Drive-through station in x-direction.
-	WID_BROS_STATION_Y,     ///< Drive-through station in y-direction.
-	WID_BROS_LT_OFF,        ///< Turn off area highlight.
-	WID_BROS_LT_ON,         ///< Turn on area highlight.
-	WID_BROS_INFO,          ///< Station acceptance info.
+	WID_BROS_CAPTION,          ///< Caption of the window.
+	WID_BROS_BACKGROUND,       ///< Background of the window.
+	WID_BROS_STATION_NE,       ///< Terminal station with NE entry.
+	WID_BROS_STATION_SE,       ///< Terminal station with SE entry.
+	WID_BROS_STATION_SW,       ///< Terminal station with SW entry.
+	WID_BROS_STATION_NW,       ///< Terminal station with NW entry.
+	WID_BROS_STATION_X,        ///< Drive-through station in x-direction.
+	WID_BROS_STATION_Y,        ///< Drive-through station in y-direction.
+	WID_BROS_STATION_AUTO,     ///< Terminal station, autoselect entry.
+	WID_BROS_STATION_XY_AUTO,  ///< Drive-through station, autoselect direction.
+	WID_BROS_LT_OFF,           ///< Turn off area highlight.
+	WID_BROS_LT_ON,            ///< Turn on area highlight.
+	WID_BROS_INFO,             ///< Station acceptance info.
 };
 
 #endif /* WIDGETS_ROAD_WIDGET_H */
diff -r e16bdc0054ce src/widgets/toolbar_widget.h
--- a/src/widgets/toolbar_widget.h
+++ b/src/widgets/toolbar_widget.h
@@ -23,9 +23,11 @@
 	WID_TN_SUBSIDIES,     ///< Subsidy menu.
 	WID_TN_STATIONS,      ///< Station menu.
 	WID_TN_FINANCES,      ///< Finance menu.
+	WID_TN_CARGOS,        ///< Transported cargo menu
 	WID_TN_COMPANIES,     ///< Company menu.
 	WID_TN_STORY,         ///< Story menu.
 	WID_TN_GOAL,          ///< Goal menu.
+	WID_TN_WATCH,         ///< Watch gui menu
 	WID_TN_GRAPHS,        ///< Graph menu.
 	WID_TN_LEAGUE,        ///< Company league menu.
 	WID_TN_INDUSTRIES,    ///< Industry menu.
diff -r e16bdc0054ce src/widgets/town_widget.h
--- a/src/widgets/town_widget.h
+++ b/src/widgets/town_widget.h
@@ -19,6 +19,7 @@
 	WID_TD_LIST,             ///< List of towns.
 	WID_TD_SCROLLBAR,        ///< Scrollbar for the town list.
 	WID_TD_WORLD_POPULATION, ///< The world's population.
+	TDW_CAPTION_TEXT,
 };
 
 /** Widgets of the #TownAuthorityWindow class. */
@@ -41,6 +42,7 @@
 	WID_TV_CHANGE_NAME,    ///< Change the name of this town.
 	WID_TV_EXPAND,         ///< Expand this town (scenario editor only).
 	WID_TV_DELETE,         ///< Delete this town (scenario editor only).
+	WID_TV_CB,
 };
 
 /** Widgets of the #FoundTownWindow class. */
@@ -62,4 +64,33 @@
 	WID_TF_LAYOUT_RANDOM,     ///< Selection for a randomly chosen town layout.
 };
 
+enum TownHK {
+	HK_SADVERT,
+	HK_MADVERT,
+	HK_LADVERT,
+	HK_ROADS,
+	HK_STATUE,
+	HK_FUND,
+};
+
+enum CBTownWidgets {
+	WID_CB_LOCATION,
+	WID_CB_ADVERT,
+	WID_CB_ADVERT_REGULAR,
+	WID_CB_FUND,
+	WID_CB_FUND_REGULAR,
+	WID_CB_POWERFUND,
+	WID_CB_DETAILS,
+	WID_CB_CARGO_NAME,
+	WID_CB_CARGO_AMOUNT,
+	WID_CB_CARGO_REQ,
+	WID_CB_CARGO_PREVIOUS,
+	WID_CB_CARGO_STORE,
+	WID_CB_CARGO_STORE_PCT,
+	WID_CB_CARGO_FROM,
+	WID_CB_CENTER_VIEW,
+	WID_CB_TOWN_VIEW,
+	WID_CB_SHOW_AUTHORITY,
+};
+
 #endif /* WIDGETS_TOWN_WIDGET_H */
diff -r e16bdc0054ce src/window.cpp
--- a/src/window.cpp
+++ b/src/window.cpp
@@ -11,6 +11,7 @@
 
 #include "stdafx.h"
 #include <stdarg.h>
+#include <limits>
 #include "company_func.h"
 #include "gfx_func.h"
 #include "console_func.h"
@@ -21,6 +22,7 @@
 #include "zoom_func.h"
 #include "vehicle_base.h"
 #include "window_func.h"
+#include "window_gui.h"
 #include "tilehighlight_func.h"
 #include "network/network.h"
 #include "querystring_gui.h"
@@ -1199,6 +1201,7 @@
 		switch (w->window_class) {
 			case WC_COMPANY_COLOUR:
 			case WC_FINANCES:
+			case WC_CARGOS:
 			case WC_STATION_LIST:
 			case WC_TRAINS_LIST:
 			case WC_ROADVEH_LIST:
@@ -2826,7 +2829,7 @@
 			case MC_DOUBLE_LEFT:
 			case MC_LEFT:
 				DEBUG(misc, 2, "Cursor: 0x%X (%d)", _cursor.sprite, _cursor.sprite);
-				if (!HandleViewportClicked(vp, x, y) &&
+				if (!HandleViewportClicked(vp, x, y, click == MC_DOUBLE_LEFT) &&
 						!(w->flags & WF_DISABLE_VP_SCROLL) &&
 						_settings_client.gui.left_mouse_btn_scrolling) {
 					_scrolling_viewport = true;
@@ -3478,3 +3481,55 @@
 	this->window_class = WC_INVALID; // stop the ancestor from freeing the already (to be) child
 	ResetObjectToPlace();
 }
+
+
+/**
+ * Sets safe-initial values.
+ * @param t The type of positioning desired.
+ */
+WindowPopup::WindowPopup(WindowDesc *desc, WindowPopupType t): Window(desc)
+{
+	this->type = t;
+	this->wpu_mod_x = -5;
+	this->wpu_mod_y = -5;
+	this->wpu_widget = std::numeric_limits<uint>::max();
+}
+
+/**
+ * Compute #WindowPopup origin Point.
+ *
+ * @param desc The window's #WindowDesc object
+ * @param sm_width Window's smallest_x.
+ * @param sm_height Window's smallest_y. Unused.
+ * @param window_number Unused.
+ * @return The origin coordinate of the window.
+ */
+/*virtual*/ Point WindowPopup::OnInitialPosition(int16 sm_width, int16 sm_height, int window_number)
+{
+	int x, y;
+
+	switch (this->type) {
+		case WPUT_CENTERED:
+			x = _cursor.pos.x - sm_width / 2;
+			y = _cursor.pos.y - this->window_desc->GetDefaultHeight() / 2;
+			break;
+		case WPUT_WIDGET_RELATIVE:
+			if (this->wpu_widget != std::numeric_limits<uint>::max()) {
+				NWidgetBase *wid = this->GetWidget<NWidgetBase>(this->wpu_widget);
+				x = _cursor.pos.x - wid->pos_x + this->wpu_mod_x;
+				y = _cursor.pos.y - wid->pos_y + this->wpu_mod_y;
+				break;
+			}
+		case WPUT_ORIGIN:
+		default:
+			x = _cursor.pos.x + this->wpu_mod_x;
+			y = _cursor.pos.y + this->wpu_mod_y;
+			break;
+	}
+
+	Point rv;
+	rv.x = Clamp(x, 0, _screen.width - sm_width);
+	rv.y = Clamp(y, GetMainViewTop(), GetMainViewBottom() - this->window_desc->GetDefaultHeight());
+	return rv;
+}
+
diff -r e16bdc0054ce src/window_gui.h
--- a/src/window_gui.h
+++ b/src/window_gui.h
@@ -17,6 +17,7 @@
 #include "company_type.h"
 #include "tile_type.h"
 #include "widget_type.h"
+#include "station_base.h"
 #include "core/smallvec_type.hpp"
 #include "core/smallmap_type.hpp"
 #include "string_type.h"
@@ -873,6 +874,8 @@
 };
 
 void GuiShowTooltips(Window *parent, StringID str, uint paramcount = 0, const uint64 params[] = NULL, TooltipCloseCondition close_tooltip = TCC_HOVER);
+void GuiPrepareTooltipsExtra(Window *parent);
+void GuiShowStationRatingTooltip(Window *parent, const Station *st, const CargoSpec *cs);
 
 /* widget.cpp */
 int GetWidgetFromPos(const Window *w, int x, int y);
@@ -905,4 +908,31 @@
 
 void ScrollbarClickHandler(Window *w, NWidgetCore *nw, int x, int y);
 
+
+/**
+ * #WindowPopup positioning types
+ */
+enum WindowPopupType {
+	WPUT_ORIGIN = 1,      ///< Align with the top-left corner of the window.
+	WPUT_WIDGET_RELATIVE, ///< Align from a nested widget.
+	WPUT_CENTERED,        ///< Center the widget under the cursor. Ignore modifiers.
+};
+
+/**
+ * Specialized Window bound to open around the cursor's position.
+ * Its sole purpose is to provide the OnInitialPosition() method
+ * and an simple interface to control its behaviour.
+ */
+struct WindowPopup: public Window {
+public:
+	WindowPopup(WindowDesc *desc, WindowPopupType t = WPUT_ORIGIN);
+	virtual Point OnInitialPosition(int16 sm_width, int16 sm_height, int window_number);
+protected:
+	uint wpu_widget; ///< The widget to which the computation would be made from when type is #WPUT_WIDGET_RELATIVE.
+	int wpu_mod_x;   ///< The X axis modifier. A negative value would bring the window closer to the left edge of the screen. Default value is -5.
+	int wpu_mod_y;   ///< The Y axis modifier. A negative value would bring the window closer to the top edge of the screen. Default value is -5.
+private:
+	WindowPopupType type;
+};
+
 #endif /* WINDOW_GUI_H */
diff -r e16bdc0054ce src/window_type.h
--- a/src/window_type.h
+++ b/src/window_type.h
@@ -109,6 +109,8 @@
 	 *   - 0 = #ToolTipsWidgets
 	 */
 	WC_TOOLTIPS,
+	WC_TOOLTIPS_EXTRA,
+	WC_STATION_RATING_TOOLTIP,
 
 	/**
 	 * Query string window; %Window numbers:
@@ -370,6 +372,12 @@
 	 */
 	WC_BUILD_OBJECT,
 
+	//watch company
+	WC_WATCH_COMPANY,
+
+	//watch company admin version
+	WC_WATCH_COMPANYA,
+
 	/**
 	 * Build vehicle; %Window numbers:
 	 *   - #VehicleType = #BuildVehicleWidgets
@@ -516,6 +524,7 @@
 	 *   - #CompanyID = #CompanyWidgets
 	 */
 	WC_FINANCES,
+	WC_CARGOS,
 
 	/**
 	 * Income graph; %Window numbers:
@@ -681,6 +690,11 @@
 	 */
 	WC_SAVE_PRESET,
 
+	WC_ZONING_TOOLBAR,
+	WC_COMMAND_TOOLBAR,
+	WC_LOGIN_WINDOW,
+	WC_CB_TOWN,
+
 	WC_INVALID = 0xFFFF, ///< Invalid window.
 };
 
diff -r e16bdc0054ce src/zoning.h
--- /dev/null
+++ b/src/zoning.h
@@ -0,0 +1,35 @@
+/** @file zoning.h */
+
+#ifndef ZONING_H_
+#define ZONING_H_
+
+#include "tile_cmd.h"
+
+enum EvaluationMode {
+	CHECKNOTHING = 0,
+	CHECKOPINION,  ///< Check the local authority's opinion.
+	CHECKBUILD,    ///< Check wither or not the player can build.
+	CHECKSTACATCH, ///< Check catchment area for stations
+	CHECKACTIVESTATIONS,  ///< Active/inactive stations (serviced in 50 days)
+	CHECKBULUNSER, ///< Check for unserved buildings
+	CHECKINDUNSER, ///< Check for unserved industries
+	CHECKTOWNZONES,  ///< Town zones (Tz*)
+	CHECKCBBORDERS,  ///< Citybuilder cargo acceptment zone
+	CHECKNEWCBBORDERS,  ///< Citybuilder cargo acceptment zone
+	CHECKCBTOWNBORDERS,  ///< Citybuilder server town borders
+	CHECKTOWNADZONES,  ///< Town advertisement zone
+	CHECKTOWNGROWTHTILES, ///< Town growth tiles (new house, skipped/removed house)
+};
+
+struct Zoning {
+	EvaluationMode inner;
+	EvaluationMode outer;
+};
+
+extern Zoning _zoning;
+
+SpriteID TileZoningSpriteEvaluation(TileIndex tile, Owner owner, EvaluationMode ev_mode);
+void DrawTileZoning(const TileInfo *ti);
+void ShowZoningToolbar();
+
+#endif /*ZONING_H_*/
diff -r e16bdc0054ce src/zoning_cmd.cpp
--- /dev/null
+++ b/src/zoning_cmd.cpp
@@ -0,0 +1,326 @@
+/** @file zoning_cmd.cpp */
+#include "stdafx.h"
+#include "station_base.h"
+#include "industry.h"
+#include "viewport_func.h"
+#include "town.h"
+#include "zoning.h"
+
+Zoning _zoning = {CHECKNOTHING, CHECKNOTHING};
+static const SpriteID INVALID_SPRITE_ID = UINT_MAX;
+//RED GREEN BLACK LIGHT_BLUE ORANGE WHITE YELLOW PURPLE
+
+/**
+ * Draw the zoning sprites.
+ * @param SpriteID image
+ *        the image
+ * @param SpriteID colour
+ *        the colour of the zoning
+ * @param TileInfo ti
+ *        the tile
+ */
+const byte _tileh_to_sprite[32] = {
+	0, 1, 2, 3, 4, 5, 6,  7, 8, 9, 10, 11, 12, 13, 14, 0,
+	0, 0, 0, 0, 0, 0, 0, 16, 0, 0,  0, 17,  0, 15, 18, 0,
+};
+
+void DrawZoningSprites(SpriteID image, SpriteID colour, const TileInfo *ti) {
+	if (colour != INVALID_SPRITE_ID){
+		AddSortableSpriteToDraw(image + _tileh_to_sprite[ti->tileh], colour, ti->x, ti->y, 0x10, 0x10, 1, ti->z + 7);
+	}
+}
+
+/**
+ * Detect whether this area is within the acceptance of any station.
+ * @param TileArea area
+ *        the area to search by
+ * @return true if a station is found
+ */
+bool IsAreaWithinAcceptanceZoneOfStation(TileArea area) {
+	int catchment = _settings_game.station.station_spread + (_settings_game.station.modified_catchment ? MAX_CATCHMENT : CA_UNMODIFIED);
+
+	StationFinder morestations(TileArea(TileXY(TileX(area.tile) - catchment / 2, TileY(area.tile) - catchment / 2),
+		TileX(area.tile) + area.w + catchment, TileY(area.tile) + area.h + catchment));
+
+	for (Station * const *st_iter = morestations.GetStations()->Begin(); st_iter != morestations.GetStations()->End(); ++st_iter) {
+		Station *st = *st_iter;
+		Rect rect = st->GetCatchmentRect();
+		return TileArea(TileXY(rect.left, rect.top), TileXY(rect.right, rect.bottom)).Intersects(area);
+	}
+	return false;
+}
+
+/**
+ * Detect whether this tile is within the acceptance of any station.
+ * @param TileIndex tile
+ *        the tile to search by
+ * @return true if a station is found
+ */
+bool IsTileWithinAcceptanceZoneOfStation(TileIndex tile) {
+	int catchment = _settings_game.station.station_spread + (_settings_game.station.modified_catchment ? MAX_CATCHMENT : CA_UNMODIFIED);
+
+	StationFinder morestations(TileArea(TileXY(TileX(tile) - catchment / 2, TileY(tile) - catchment / 2),
+		catchment, catchment));
+
+	for (Station * const *st_iter = morestations.GetStations()->Begin(); st_iter != morestations.GetStations()->End(); ++st_iter) {
+		Station *st = *st_iter;
+		Rect rect = st->GetCatchmentRect();
+		if ((uint)rect.left <= TileX(tile) && TileX(tile) <= (uint)rect.right
+			&& (uint)rect.top <= TileY(tile) && TileY(tile) <= (uint)rect.bottom )
+		{
+			return true;
+		}
+	}
+	return false;
+}
+
+//Check the opinion of the local authority in the tile.
+SpriteID TileZoneCheckOpinionEvaluation(TileIndex tile, Owner owner) {
+	Town *town = ClosestTownFromTile(tile, _settings_game.economy.dist_local_authority);
+
+	if (town == NULL) return INVALID_SPRITE_ID; // no town
+	else if (HasBit(town->have_ratings, owner)) {  // good : bad
+		int16 rating = town->ratings[owner];
+		if(rating <= RATING_APPALLING) return SPR_PALETTE_ZONING_RED;
+		if(rating <= RATING_POOR) return SPR_PALETTE_ZONING_ORANGE;
+		if(rating <= RATING_MEDIOCRE) return SPR_PALETTE_ZONING_YELLOW;
+		if(rating <= RATING_GOOD) return SPR_PALETTE_ZONING_WHITE;
+		if(rating <= RATING_VERYGOOD) return SPR_PALETTE_ZONING_PURPLE;
+		if(rating <= RATING_EXCELLENT) return SPR_PALETTE_ZONING_LIGHT_BLUE;
+		return SPR_PALETTE_ZONING_GREEN;
+	}
+	else {
+		return SPR_PALETTE_ZONING_BLACK;      // no opinion
+	}
+}
+
+//Check whether the player can build in tile.
+SpriteID TileZoneCheckBuildEvaluation(TileIndex tile, Owner owner) {
+	/* Let's first check for the obvious things you cannot build on */
+	switch ( GetTileType(tile) ) {
+		case MP_INDUSTRY:
+		case MP_OBJECT:
+		case MP_HOUSE:
+			return SPR_PALETTE_ZONING_RED; //can't build
+		case MP_STATION:
+		case MP_TUNNELBRIDGE:
+		case MP_ROAD:
+		case MP_RAILWAY: {
+			if (GetTileOwner(tile) != owner) return SPR_PALETTE_ZONING_RED; //can't build
+			else return INVALID_SPRITE_ID;
+		}
+		default: return INVALID_SPRITE_ID;
+	}
+}
+
+//Detect whether the tile is within the catchment zone of a station.
+//black if within, light blue if only in acceptance zone and nothing if no nearby station.
+ SpriteID TileZoneCheckStationCatchmentEvaluation(TileIndex tile) {
+	// Never on a station.
+	if (IsTileType(tile, MP_STATION)){
+		return INVALID_SPRITE_ID;
+	}
+	// For provided goods
+	StationFinder stations(TileArea(tile, 1, 1));
+	if (stations.GetStations()->Length() > 0) {
+		return SPR_PALETTE_ZONING_GREEN;
+	}
+	// For accepted goods
+	if (IsTileWithinAcceptanceZoneOfStation(tile)){
+		return SPR_PALETTE_ZONING_LIGHT_BLUE;
+	}
+	return INVALID_SPRITE_ID;
+}
+
+//Detect whether a building is unserved by a station of owner.
+//return red if unserved, orange if only accepting, nothing if served or not a building
+SpriteID TileZoneCheckUnservedBuildingsEvaluation(TileIndex tile) {
+	CargoArray dat;
+
+	if (IsTileType (tile, MP_HOUSE))
+		//&& ( ( memset(&dat, 0, sizeof(dat)), AddAcceptedCargo(tile, dat, NULL), (dat[CT_MAIL] + dat[CT_PASSENGERS] > 0) )
+		//	|| ( memset(&dat, 0, sizeof(dat)), AddProducedCargo(tile, dat), (dat[CT_MAIL] + dat[CT_PASSENGERS] > 0) ) ) )
+	{
+		StationFinder stations(TileArea(tile, 1, 1));
+
+		if (stations.GetStations()->Length() > 0) {
+			return INVALID_SPRITE_ID;
+		}
+		// For accepted goods
+		if (IsTileWithinAcceptanceZoneOfStation(tile)){
+			return SPR_PALETTE_ZONING_ORANGE;
+		}
+		return SPR_PALETTE_ZONING_RED;
+	}
+	return INVALID_SPRITE_ID;
+}
+
+//Detect whether an industry is unserved by a station of owner.
+//return red if unserved, orange if only accepting, nothing if served or not a building
+SpriteID TileZoneCheckUnservedIndustriesEvaluation(TileIndex tile) {
+	if (IsTileType(tile, MP_INDUSTRY)) {
+		Industry *ind = Industry::GetByTile(tile);
+		StationFinder stations(ind->location);
+
+		if (stations.GetStations()->Length() > 0){
+			return INVALID_SPRITE_ID;
+		}
+
+		// For accepted goods
+		if (IsAreaWithinAcceptanceZoneOfStation(ind->location)){
+			return SPR_PALETTE_ZONING_ORANGE;
+		}
+		return SPR_PALETTE_ZONING_RED;
+	}
+	return INVALID_SPRITE_ID;
+}
+
+//Check which town zone tile belongs to.
+SpriteID TileZoneCheckTownZones(TileIndex tile) {
+	HouseZonesBits next_zone = HZB_BEGIN, tz = HZB_END;
+
+	Town *town;
+	FOR_ALL_TOWNS(town) {
+		while (next_zone < HZB_END
+			&& (town->cache.squared_town_zone_radius[next_zone] == 0
+				|| DistanceSquare(tile, town->xy) <= town->cache.squared_town_zone_radius[next_zone])
+		){
+			if(town->cache.squared_town_zone_radius[next_zone] != 0)  tz = next_zone;
+			next_zone++;
+		}
+	}
+
+	switch (tz) {
+		case HZB_TOWN_EDGE:         return SPR_PALETTE_ZONING_LIGHT_BLUE; // Tz0
+		case HZB_TOWN_OUTSKIRT:     return SPR_PALETTE_ZONING_RED; // Tz1
+		case HZB_TOWN_OUTER_SUBURB: return SPR_PALETTE_ZONING_YELLOW; // Tz2
+		case HZB_TOWN_INNER_SUBURB: return SPR_PALETTE_ZONING_GREEN; // Tz3
+		case HZB_TOWN_CENTRE:       return SPR_PALETTE_ZONING_WHITE; // Tz4 - center
+		default:                    return INVALID_SPRITE_ID; // no town
+	}
+	return INVALID_SPRITE_ID;
+}
+
+//Check CB town acceptance area
+SpriteID TileZoneCheckNewCBBorders(TileIndex tile) {
+	Town *town;
+	FOR_ALL_TOWNS(town) {
+		if (DistanceSquare(tile, town->xy) <= town->cache.squared_town_zone_radius[0] + 30)
+			return SPR_PALETTE_ZONING_BLACK;
+	}
+	return INVALID_SPRITE_ID;
+}
+
+//Check CB town acceptance area
+SpriteID TileZoneCheckCBBorders(TileIndex tile) {
+	Town *town = CalcClosestTownFromTile(tile);
+
+	if (town != NULL) {
+		if (DistanceManhattan(town->xy, tile) <= _settings_client.gui.cb_distance_check) {
+			return SPR_PALETTE_ZONING_LIGHT_BLUE; //cb catchment
+		}
+	}
+	return INVALID_SPRITE_ID; // no town
+}
+
+//Check whether the tile is within citybuilder server town border (where houses could be built)
+SpriteID TileZoneCheckCBTownBorders(TileIndex tile) {
+	Town *town;
+	FOR_ALL_TOWNS(town) {
+		uint32 distMax = DistanceMax(town->xy, tile);
+		if (distMax * distMax < town->cache.squared_town_zone_radius[0]){
+			return SPR_PALETTE_ZONING_GREEN;
+		}
+	}
+	return INVALID_SPRITE_ID;
+}
+
+//Check which advertisement zone(small, medium, large) tile belongs to
+SpriteID TileZoneCheckTownAdvertisementZones(TileIndex tile) {
+	Town *town = CalcClosestTownFromTile(tile, 21U);
+	if (town == NULL) return INVALID_SPRITE_ID; //nothing
+
+	uint dist = DistanceManhattan(town->xy, tile);
+
+	if (dist <= 10) return SPR_PALETTE_ZONING_GREEN;
+	if (dist <= 15) return SPR_PALETTE_ZONING_YELLOW;
+	if (dist <= 20) return SPR_PALETTE_ZONING_LIGHT_BLUE;
+	return INVALID_SPRITE_ID;
+}
+
+//Checks for tile in growth tiles info
+SpriteID TileZoneCheckTownsGrowthTiles(TileIndex tile) {
+	switch (max(_towns_growth_tiles[tile], _towns_growth_tiles_last_month[tile])) {
+		case TGTS_CB_HOUSE_REMOVED_NOGROW: return SPR_PALETTE_ZONING_LIGHT_BLUE;
+		case TGTS_RH_REMOVED:              return SPR_PALETTE_ZONING_LIGHT_BLUE;
+		case TGTS_RH_REBUILT:              return SPR_PALETTE_ZONING_WHITE;
+		case TGTS_NEW_HOUSE:               return SPR_PALETTE_ZONING_GREEN;
+		case TGTS_CYCLE_SKIPPED:           return SPR_PALETTE_ZONING_ORANGE;
+		case TGTS_HOUSE_SKIPPED:           return SPR_PALETTE_ZONING_YELLOW;
+		case TGTS_CB_HOUSE_REMOVED:        return SPR_PALETTE_ZONING_RED;
+		default: return INVALID_SPRITE_ID;
+	}
+}
+
+// For station shows whether it is active
+SpriteID TileZoneCheckActiveStations(TileIndex tile) {
+	// Never on a station.
+	if (!IsTileType(tile, MP_STATION)){
+		return INVALID_SPRITE_ID;
+	}
+
+	Station *st = Station::GetByTile(tile);
+	if (st == NULL) {
+		return INVALID_SPRITE_ID;
+	}
+
+	if (st->time_since_load <= 20 || st->time_since_unload <= 20) {
+		return SPR_PALETTE_ZONING_GREEN;
+	}
+
+	return SPR_PALETTE_ZONING_RED;
+}
+
+
+/**
+ * General evaluation function; calls all the other functions depending on
+ * evaluation mode.
+ * @param TileIndex tile
+ *        Tile to be evaluated.
+ * @param EvaluationMode ev_mode
+ *        The current evaluation mode.
+ * @return The colour returned by the evaluation functions (none if no ev_mode).
+ */
+SpriteID TileZoningSpriteEvaluation(TileIndex tile, Owner owner, EvaluationMode ev_mode) {
+	switch (ev_mode) {
+		case CHECKOPINION:     return TileZoneCheckOpinionEvaluation(tile, owner);
+		case CHECKBUILD:       return TileZoneCheckBuildEvaluation(tile, owner);
+		case CHECKSTACATCH:    return TileZoneCheckStationCatchmentEvaluation(tile);
+		case CHECKBULUNSER:    return TileZoneCheckUnservedBuildingsEvaluation(tile);
+		case CHECKINDUNSER:    return TileZoneCheckUnservedIndustriesEvaluation(tile);
+		case CHECKTOWNZONES:   return TileZoneCheckTownZones(tile);
+		case CHECKCBBORDERS:   return TileZoneCheckCBBorders(tile);
+		case CHECKNEWCBBORDERS:   return TileZoneCheckNewCBBorders(tile);
+		case CHECKCBTOWNBORDERS: return TileZoneCheckCBTownBorders(tile);
+		case CHECKTOWNADZONES: return TileZoneCheckTownAdvertisementZones(tile);
+		case CHECKTOWNGROWTHTILES: return TileZoneCheckTownsGrowthTiles(tile);
+		case CHECKACTIVESTATIONS: return TileZoneCheckActiveStations(tile);
+		default:               return INVALID_SPRITE_ID;
+	}
+}
+
+/**
+ * Draw the the zoning on the tile.
+ * @param TileInfo ti
+ *        the tile to draw on.
+ */
+void DrawTileZoning(const TileInfo *ti) {
+	if(_zoning.outer == CHECKNOTHING && _zoning.inner == CHECKNOTHING) return; //nothing to do
+	if (_game_mode != GM_NORMAL || ti->tile >= MapSize() || IsTileType(ti->tile, MP_VOID)) return; //check invalid
+	if (_zoning.outer != CHECKNOTHING){
+		DrawZoningSprites(SPR_SELECT_TILE, TileZoningSpriteEvaluation(ti->tile, _local_company, _zoning.outer), ti);
+	}
+	if (_zoning.inner != CHECKNOTHING){
+		DrawZoningSprites(SPR_INNER_HIGHLIGHT_BASE, TileZoningSpriteEvaluation(ti->tile, _local_company, _zoning.inner), ti);
+	}
+}
